import sys
import os
import argparse
import re
import pdb

def make_argparser():
    parser = argparse. ArgumentParser()
    parser. add_argument ( "-i", "--iterations", help="number of iterations", type=int )
    parser. add_argument ( "-r", "--random-seed", help="random seed", type=int )
    parser. add_argument ( "-k", "--num-states", help="number of states", type=int )
    parser. add_argument (       "--wseq", help=".wseq filename" )
    parser. add_argument (       "--tseq", help=".tseq filename" )
    parser. add_argument (       "--wlex", help=".wlex filename" )
    parser. add_argument (       "--tlex", help=".tlex filename" )
    parser. add_argument (       "--wfeats", help=".wfeats filename" )
    parser. add_argument (       "--wflex", help=".wflex filename" )
    parser. add_argument ( "-d", "--dict", help=".dict filename" )
    parser. add_argument ( "-o", "--outfile", help=".dict filename" )
    parser. add_argument (       "--alpha-emission", help="hyperparameter for emission", type=float )
    parser. add_argument (       "--alpha-transition", help="hyperparameter for transition", type=float )
    parser. add_argument (       "--alpha-tag", help="hyperparameter for type-level tag", type=float )
    parser. add_argument (       "--alpha-features", help="hyperparameter for type-level features", type=float )
    parser. add_argument (       "--approx", help="approximate inference", action="store_true" )
    parser. add_argument (       "--use-dict", help="use dictionary", action="store_true" )
    parser. add_argument (       "--init", help="initialization method", type=int )
    parser. add_argument ( "-s", "--resample", help="resample hyperparameters", type=int )
    return parser

def main():
    p = make_argparser()
    args = p. parse_args ( sys.argv[1:] )
    print >>sys.stderr, args

    if args. wseq : print "wseq = %s" % args. wseq
    if args. tseq : print "tseq = %s" % args. tseq
    if args. wlex : print "wlex = %s" % args. wlex
    if args. tlex : print "tlex = %s" % args. tlex
    if args. dict : print "dict = %s" % args. dict
    if args. wfeats : print "wfeats = %s" % args. wfeats
    if args. wflex : print "wflex = %s" % args. wflex
    if args. random_seed != None : print "random-seed = %d" % args. random_seed
    if args. iterations : print "iterations = %d" % args. iterations
    if args. num_states : print "num-states = %d" % args. num_states
    if args. alpha_emission : print "alpha-emission = %s" % args. alpha_emission
    if args. alpha_transition : print "alpha-transition = %s" % args. alpha_transition
    if args. alpha_tag : print "alpha-tag = %s" % args. alpha_tag
    if args. alpha_features : print "alpha-features = %s" % args. alpha_features
    if args. approx : print "approx = 1"
    if args. use_dict : print "use-dict = 1"
    if args. outfile : print "outfile = %s" % args. outfile
    if args. init != None: print "init = %d" % args. init
    if args. resample: print "resample = %d" % args. resample
if __name__ == '__main__':
    main()
