import sys
import pdb
import argparse

def make_argparser():
    parser = argparse.ArgumentParser(description="Make UTF-8 file morfessor compliant (8-bit only)")
    parser. add_argument('--test','-t',help="test if convertable", default=False,action='store_true')
    parser. add_argument('infilename',nargs=1,help="input filename")
    return parser

def get_utf8_to_8bit_map_from_set ( utf8_charset ):
    m = {}
    base = 128 + 4
    for c in utf8_charset:
        if ord(c) < 128:
            if c == u'*':
                m [c] = chr(128)
            elif c == u'/':
                m [c] = chr(128 + 1)
            elif c == u'+':
                m [c] = chr(128 + 2)
            elif c == u'#':
                m [c] = chr(128 + 3)
            else:
                m [c] = c.encode('ascii')
        else:
            if c not in m:
                if base >= 256:
                    return None
                else:
                    m [c] = chr(base)
                    base = base + 1
    return m

def get_utf8_to_8bit_map ( infile ):
    utf8_charset = set ( c
                         for line in infile
                         for c in line.decode("utf-8") )

    return get_utf8_to_8bit_map_from_set ( utf8_charset )
                
def main():
    p = make_argparser()
    opts = p. parse_args ( sys.argv[1:])
    print >>sys.stderr,opts
    charmap = get_utf8_to_8bit_map ( open(opts.infilename[0]) )
    if opts.test:
        return 1 if charmap == None else 0 # 1- error
    else:
        for line in open(opts.infilename[0]):
            for i in line.decode("utf-8"):
                sys.stdout. write ( charmap[i] )
    
if __name__ == '__main__':
    main()
