#include <cstdlib>
#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <boost/bind.hpp>
#include <boost/lambda/lambda.hpp>

using namespace std;
using namespace boost::lambda;

struct A {
  int x;
  int y;
  A(int i): x(i), y(-i) {}
};

ostream& operator<<(ostream& outs, const A& a)
{
  outs << "x = " << a.x << " y = " << a.y;
  return outs;
}

struct Axless : public binary_function<bool,A,A> {
  bool operator()(const A& a, const A& b) 
  {
    return a.x < b.x;
  }
};
int main()
{
  vector<A> v;
  for(int i = 0; i < 10; ++i)
    v.push_back(A(i));
  cout <<
//     max_element(v.begin(), v.end(), boost::bind(std::less<int>(), 
//                                                 boost::bind(&A::x,boost::lambda::_1), 
//                                                 boost::bind(&A::x,boost::lambda::_2)))->x
    max_element(v.begin(), v.end(), Axless() )->x
       << endl;
  return 0;
}
